demo/articulos/urls.py
from django.urls import path

from articulos import views

app_name = "articulos"

urlpatterns =[
    path('list_articulo/', views.ListArticulo.as_view(), name="list_articulo"),
    path('new_articulo/', views.NewArticulo.as_view(), name="new_articulo"),
]

demo/demo/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("home.urls", namespace="home")),
    path('pinturas/', include("pinturas.urls", namespace="pinturas")),
    path('articulos/', include("articulos.urls", namespace="articulos")),
]

demo/articulos/models.py
from django.db import models

from pinturas.models import BaseModel,Obra,Artista

# Create your models here.

class Articulo(BaseModel):
    description = models.CharField(max_length=128, unique=True)
    obra = models.ForeignKey(Obra, on_delete=models.CASCADE)
    artista = models.ForeignKey(Artista, on_delete=models.CASCADE)



    def __str__(self):
        return "{}".format(self.description)


    def save(self):
        self.description = self.description.upper()
        super(Articulo, self).save()


    class  Meta:
        verbose_name_plural = "Articulos"

demo/articulos/forms.py
from django import forms

from .models import Articulo


class NewArticuloForm(forms.ModelForm):
    class Meta:
        model = Articulo
        fields = [
            "description",
            "obra",
            "artista",
        ]
        labels = {
            "description": "Nombre del articulo",
            "obra": "Obra",
            "artista": "Artista"
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })

demo/articulos/views.py
from django.shortcuts import render
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy

from .models import Articulo
from .forms import NewArticuloForm
# Create your views here.

##### CRUD ARTICULO #####

## Create
## generic.CreateView
class NewArticulo(LoginRequiredMixin, generic.CreateView):
    template_name = "articulos/new_articulo.html"
    model = Articulo
    context_object_name = "obj"
    form_class = NewArticuloForm
    login_url = "home:login"
    success_url = reverse_lazy("articulos:list_articulo")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)


## Retrieve
# generic.ListView
class ListArticulo(LoginRequiredMixin, generic.ListView):
    template_name = "articulos/list_articulo.html"
    queryset = Articulo.objects.all()
    login_url = "home:login"
    context_object_name = "obj"

## Update

class UpdateArticulo(LoginRequiredMixin, generic.UpdateView):
    template_name = "articulos/new_articulo.html"
    model = Articulo
    context_object_name = "obj"
    form_class = NewArticuloForm
    login_url = "home:login"
    success_url = reverse_lazy("articulos:list_articulo")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)
## Delete

demo/templates/articulos/list_articulo.html
{% extends "base.html" %}

{% block title %}Provider List{% endblock title %}

{% block page_content %}


<!-- Dropdown Card Example -->
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Articulo</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Actions:</div>
        <a class="dropdown-item" href="{% url 'articulos:new_articulo' %}"><i class="far fa-calendar-plus"></i>NewArticle</a>
        <a class="dropdown-item" href=""></a>
        <div class="dropdown-divider"></div>
        <a class="dropdown-item" href="#">Something else here</a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
      <h3> Not Articles Yet!! </h3>
    {% else %}
      <table class="table table-striped table-hover">
        <thead>
          <th> Id </th>
          <th> Description </th>
          <th> Obra </th>
          <th> Artista </th>
          <th> Status </th>
          <th> TimeStamp </th>
          <th> Update </th>
          <th class="all"> Actions </th>
        </thead>
        <tbody>
          {% for item in obj %}
             <tr>
               <th>{{ item.id }}</th>
               <th>{{ item.description }}</th>
               <th>{{ item.obra }}</th>
               <th>{{ item.artista }}</th>
               <th>{{ item.status|yesno:"Active, Inactive" }}</th>
               <th>{{ item.timestamp|date:"d/m/Y H:i:s" }}</th>
               <th>{{ item.update|date:"d/m/Y H:i:s" }}</th>
               <th>
                 <a href="{#% url 'inv:update_category' item.pk %#}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                 <a href="{#% url 'inv:delete_category' item.pk %#}" class="btn btn-danger btn-circle" role="button"><i class="far fa-trash-alt"></i></a>
               </th>
             </tr>
          {% endfor %}
        </tbody>
      </table>
    {% endif %}
  </div>
</div>



{% endblock page_content %}

{% block js_scripts %}
  <script type="text/javascript">
    // Call the DataTable JQuery plugin//
    $(document).ready(function(){
      $('.table').DataTable();
    });
  </script>>
{% endblock js_scripts %}

demo/templates/articulos/new_articulo.html
{% extends "base.html" %}

{% block title %}New Articulo{% endblock title %}

{% block page_content %}

<div class="modal-dialog modal-lg ">
  <div class="modal-content">



<!-- Earnings (Monthly) Card Example -->
<form class="form-inline" rol="form" method="POST" action="">

  {% csrf_token  %}

  <div class="col-xl-12 col-md-6 mb-6">
    {% if obj %}
      <div class="card border-left-primary shadow h-100 py-2">
    {% else %}
      <div class="card border-left-success shadow h-100 py-2">
    {% endif %}
      <div class="card-body">
        <div class="row no-gutters align-items-center">
          <div class="col mr-2">
            <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
              {% if obj %} Edit {% else %} New {% endif %} Articulo
            </div>
                <!-- {{ form }} -->
                <div class="dropdown-divider"> </div>

                <!-- ROW -->
                 <div class="row">
                     <div class="col-3">
                        {{ form.as_p }}
                    </div>
                </div>
                </div>

              <!-- ENDROW -->




              <div class="dropdown-divider"></div>

                <div class="row">
                  <div class="col">
                    <button type="submit" name="button" class="btn btn-success"><span class="fa fa-save"></span> Save</button>
                    <a href="{% url 'articulos:list_articulo' %}" class="btn btn-warning"><span class="fa fa-undo"></span> Cancel</a>
                  </div>
                </div>



          </div>

        </div>
      </div>
    </div>
  </div>

</form>

</div>
</div>

{% endblock page_content %}

{% block js_scripts %}
{% endblock js_scripts %}